#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "useful.h"

int print (char *s)
{
        int i;
	for (i = 0; i < strlen (s); i++)
	{
	        printf ("%c", s[i]);
		if (i % 80 == 79)
		        printf ("\n");
	}
	return (i);
}

int main (int argc, char* argv[])
{
        int i, largo;
	FILE *in;
	char *patron, *str, *name, c;
	bool remove;
	if (argc < 3 || argc > 4)
	{
		printf ("Usage %s <input file name> <pattern> [<-r to remove pattern>]\n", argv[0]);
		exit(0);
	}
	in = fopen (argv[1], "rb");
	if (in == NULL)
	{
		printf ("File %s not found\n", argv[1]);
		exit(0);
	}
	remove = argc == 3 ? false: strcmp (argv[3], "-r")? false: true;
	patron = argv[2];
	largo = strlen(patron);
	str =  new char[largo + 1];
	str[largo] = '\0';
	name = new char[1000];
	for (c = get(in); c != EOF;)
	{
	        for (i = 0, c = getc (in); c != '\n'; i++, c = getc(in))
		        name[i] = c;
                name[i] = '\0';
		for (i = 0, c = get(in); i < largo && c != '>'; i++, c = get(in))
		        str[i] = c;
                if (c != '>')
		{
		        if (!strcmp (patron, str))
			{
                                printf (">%s\n", name);
				for (i = (remove? 0:print (str)); c != '>' && c != EOF; i++, c = get(in))
				{
				        printf ("%c", c);
					if (i % 80 == 79)
				        	printf ("\n");
                                }
                                if (i % 80)
				        printf ("\n");
                        }
			else
			        for (c = get(in); c != '>' && c != EOF; c = get(in));
		}
	}
	fclose (in);
}
